####################### [i-dreams.net] - guestbook ############################
# backup.pl  		                                                          #
###############################################################################

sub generate_boundary() {
    my $unique_id = crypt(time(), $to) .
                    crypt(time(), $from);
    return "----_=_$unique_id";
}
sub get_mime_type {
    my $filename = shift;
    my %types = ( 'tar' => 'application/x-tar',  'zip' => 'application/x-zip-compressed' );
    chomp(my $typ = [split(/\./, $filename)]->[-1]);
    return ( $types{$typ} or 'application/octet-stream');
}

sub base64enc {
   open(F, "$ziel") or die "$txt_gl{'119'}: $ziel";
    my @b64str = ("A".."Z","a".."z","0".."9","+","/");
    my($buflen,$num,$len,$dat,@dat,$a,$b,$c,$d,$e,$f,$g);
    $buflen=300*3;
    $num=0;
    { local $^W = 0;
      while (!eof(F)) {
          $len=read(F, $dat, $buflen);
          @dat=unpack('C*', $dat);
          while (@dat) {
              $a=shift(@dat);
              $b=shift(@dat);
              $c=shift(@dat);
              if ($b eq "") {
                  ($d,$e)=($a>>2, ($a<<4)&0x3f);
                  $savefile .= "$b64str[$d]$b64str[$e]==";
              } elsif ($c eq "") {
                  ($d,$e,$f)=(($a>>2),
                  ((($a<<4)&0x3f) | $b>>4), ($b<<2)&0x3f);
                  $savefile .= "$b64str[$d]$b64str[$e]$b64str[$f]=";
              } else {
                  ($d,$e,$f,$g)=
                      ($a>>2,
                       (($a<<4)&0x3f) | $b>>4,
                       ($b<<2)&0x3f | $c>>6,
                       $c&0x3f);
                  $savefile .= "$b64str[$d]$b64str[$e]$b64str[$f]$b64str[$g]";
              }
              if (++$num==15) { $savefile .= "\n"; $num=0;}
          }
      }
    }
    $savefile .= "\n" unless ($num==0);
	close(F);
}
sub backupaccounts {

$timestamp = "";
if ($stampbaks) {
($day, $month, $year) = (localtime)[3,4,5];
$year = $year + 1900; $month++;
$timestamp = "_$month-$day-$year";
}
if ($saveyear) {
$leveldat .= qq~\$level = qq\~$level\~;
\$actiondates = qq\~$mon_num.$mday.$saveyear\~;
1;
~;
&writefile("$datadir/admdat/level.dat",$leveldat);
}

if ($backupmode == 1) { $type = "tar"; }
elsif ($backupmode == 2) { $type = "tar.gz"; }
elsif ($backupmode == 3) { $type = "zip"; }

$ziel = "$backuppath/backup$timestamp.$type";
$bcheck = "backup$timestamp.$type";

if (-e "$ziel") { &dounlink("$ziel"); }

fopen(FILE, ">$ordnerdir/backup.lock");
print FILE "\n";
fclose(FILE);
chmod (0666, "$ordnerdir/backup.lock");

$datum = time;
$writelastb = qq~$datum|$backupmode|$backupmail|$bcheck\n~;
&writefile("$backuppath/lastbinfo.txt",$writelastb);
chmod (0666, "$backuppath/lastbinfo.txt");

if ($backupmode == 1) {
	@the = `tar -c -v -f $ziel $backupwhere`; 
	unless ($the[0]) {  &fatal_error($txt_gl{'131'}); }
}
elsif ($backupmode == 2) {
	$ziel =~ s/\.tar$/\.tar.gz/ig;
	$bcheck =~ s/\.tar$/\.tar.gz/ig;
	@the = `tar -c -z -v -f $ziel $backupwhere`;
	unless ($the[0]) { &fatal_error($txt_gl{'131'}); }
}
else {
foreach $incpath (@INC) {
	if (-e "$incpath/Compress/Zlib.pm") { $inchere = 1;	}
}
if ($inchere == 1) { 	
	require "$subsdir/zip.pl"
}
else { &fatal_error($txt_gl{'130'}); }
}

chmod (0777, "$ziel");
&dounlink("$ordnerdir/backup.lock");


if (($backupmail == 2) || ($backupmail == 3)) {
	$dateix = (-s "$ziel");
	$dateix = sprintf("%.2f", $dateix / 1048576 );
	$dateix = sprintf("%.2f", $dateix);
	$boundary = &generate_boundary();

	$backupfuncon = 1;
	$mailfusr = "plain";
	&openfile("$mail9path","mail9");

		foreach $curmail (@mail9) {
				$curmail =~ tr/\n//d;
		$curmail =~ tr/\r//d;
		$curmail =~ s/\+fbname\+/$fi_fbname/g;
		$curmail =~ s/\+script\+/$script/gi;
		$curmail =~ s/\+filename\+/$bcheck/g;
		$curmail =~ s/\+filesize\+/$dateix/g;
		$mail9 .= qq~$curmail\n~;
		}
	&sendmail2($admmail, "$fi_fbname: $txt_gl{'120'}", "$mail9");
}

if ($backupmail == 2) { &dounlink("$ziel"); }
}
1;