####################### [i-dreams.net] - guestbook ############################
# guard.pl     		                                                          #
###############################################################################

unless ($loaded_guardtxt) { require "$datadir/language/$sprache2/guard.lng"; $loaded_guardtxt = 1; }
$time = time;
&formatdatum("$time","datum");

sub guard {

	$proxy0 = &get_remote_addr;
	$proxy1 = &get_x_ip_client;
	$proxy2 = &get_x_forwarded;
	$proxy3 = &get_http_via;
	@white_list = split(/\|/,$black_proxy);
	foreach (@white_list) {
		chomp $_;
 		if (($proxy0 =~ m/$_/ || $proxy1 =~ m/$_/ || $proxy2 =~ m/$_/ || $proxy3 =~ m/$_/) && $_ ne "") { $white_proxyed = 1; last;}
	}
	if($deny_proxy && !$white_proxyed && ($proxy1 ne "empty" || $proxy2 ne "empty" || $proxy3 ne "empty")) {
		if($notify_proxy){
			$abuse_subject = qq~$txt_gl{'132'}-($fi_fbname): $txt_gd{'1'} $txt_gd{'2'}~;
			$abuse_mail = qq~$txt_gd{'1'} $txt_gd{'2'} $txt_gl{'122'} $datum\n\n$txt_gd{'3'}: (REMOTE_ADDR)->$proxy0, (X_IP_CLIENT)->$proxy1, (HTTP_X_FORWARDED_FOR)->$proxy2, (HTTP_VIA)->$proxy3\n~;
			if($addip_proxy){
				$abuse_mail .= qq~$txt_gd{'4'}: $user_ip,\n\n~;
			}
			$abuse_mail .= qq~$fi_fbname, $txt_gl{'132'}~;
			&notifyadmin;
		}
		if($addip_proxy){
			&writefile("$datadir/admdat/bannip.dat","$user_ip\n","add");
		}
		$actionfree = 1;
		&fatal_error("$txt_gd{'17'}");
	}
	
	$querystring = &get_query_string;
	
	if($deny_referer) {
		@refererlist = split(/\|/,$black_referer);
		$streferer = &get_referer;
		foreach (@refererlist) {
			chomp $_;
			if ($streferer=~ m/$_/ && $_ ne "") {
				if($notify_referer){
		
				$abuse_subject = qq~$txt_gl{'132'}-($fi_fbname): $txt_gd{'5'} $txt_gd{'2'}~;
				$abuse_mail = qq~$txt_gd{'5'} $txt_gd{'2'} $txt_gl{'122'} $datum\n\n$txt_gd{'3'}: $user_ip\n~;
				if($addip_referer){
				$abuse_mail .= qq~$txt_gd{'4'}: $user_ip,\n\n~;
				}
				$abuse_mail .= qq~$txt_gd{'6'}: $streferer\n\n~;
				$abuse_mail .= qq~$fi_fbname, $txt_gl{'132'}~;
				&notifyadmin;
				}
				if($addip_referer){
					&writefile("$datadir/admdat/bannip.dat","$user_ip\n","add");
				}
				$actionfree = 1;
				&fatal_error("$txt_gd{'18'}");
			}
		}
	}
	
	if($deny_harvester) {
		@harvesterlist = split(/\|/,$black_harvester);
		$agent = &get_user_agent;
		foreach (@harvesterlist) {
			chomp $_;
			if ($agent=~ m/$_/ && $_ ne "") {
				if($notify_harvester){
				$abuse_subject = qq~$txt_gl{'132'}-($fi_fbname): $txt_gd{'8'} $txt_gd{'2'}~;
				$abuse_mail = qq~$txt_gd{'8'} $txt_gd{'2'} $txt_gl{'122'} $datum\n\n$txt_gd{'3'}: $user_ip\n~;
				if($addip_harvester){
				$abuse_mail .= qq~$txt_gd{'4'}: $user_ip,\n\n~;
				}
				$abuse_mail .= qq~$txt_gd{'7'}: $agent\n\n~;
				$abuse_mail .= qq~$fi_fbname, $txt_gl{'132'}~;
				&notifyadmin;
				}
				if($addip_harvester){
					&writefile("$datadir/admdat/bannip.dat","$user_ip\n","add");
				}
				$actionfree = 1;
				&fatal_error("$txt_gd{'19'}");
			}
		}
	}
	
	if($deny_request) {
		@requestlist = split(/\|/,$black_request);
		$method = &get_request_method;
		foreach (@requestlist) {
			chomp $_;
			if ($method=~ m/$_/ && $_ ne "") {
				if($notify_request){
				$abuse_subject = qq~$txt_gl{'132'}-($fi_fbname): $txt_gd{'10'} $txt_gd{'2'}~;
				$abuse_mail = qq~$txt_gd{'10'} $txt_gd{'2'} $txt_gl{'122'} $datum\n\n$txt_gd{'3'}: $user_ip\n~;
				if($addip_request){
				$abuse_mail .= qq~$txt_gd{'4'}: $user_ip,\n\n~;
				}
				$abuse_mail .= qq~$txt_gd{'9'}: $method\n\n~;
				$abuse_mail .= qq~$fi_fbname, $txt_gl{'132'}~;
				&notifyadmin;
				}
				if($addip_request){
					&writefile("$datadir/admdat/bannip.dat","$user_ip\n","add");
				}
				$actionfree = 1;
				&fatal_error("$txt_gd{'20'}");
			}
		}
	}
	
	if($deny_string) {
		@stringlist = split(/\|/,$black_string);
		foreach (@stringlist) {
			chomp $_;
			if ($querystring =~ m/$_/ && $_ ne "") {
				if($notify_string){
				$abuse_subject = qq~$txt_gl{'132'}-($fi_fbname): $txt_gd{'13'} $txt_gd{'2'}~;
				$abuse_mail = qq~$txt_gd{'13'} $txt_gd{'2'} $txt_gl{'122'} $datum\n\n$txt_gd{'3'}: $user_ip\n~;
				if($addip_string){
				$abuse_mail .= qq~$txt_gd{'4'}: $user_ip,\n\n~;
				}
				$abuse_mail .= qq~$txt_gd{'11'}: $_\n~;
				$abuse_mail .= qq~$txt_gd{'12'}: $querystring\n\n~;
				$abuse_mail .= qq~$fi_fbname, $txt_gl{'132'}~;
				&notifyadmin;
				}
				if($addip_string){
					&writefile("$datadir/admdat/bannip.dat","$user_ip\n","add");
				}
				$actionfree = 1;
				&fatal_error("$txt_gd{'21'} ($_)");
			}
		}
	}
	
	if($deny_script) {
		&isadmin2;
		if ($killthelogin == 1) {
		while( ($key,$secvalue) = each(%INFO) ) {
			$secvalue = lc($secvalue);
			&str_replace("%3c", "<", $secvalue);
			&str_replace("%3e", ">", $secvalue);
			if (($secvalue =~ m/<[^>]script*\"?[^>]*>/ig) || ($secvalue =~ m/<[^>]*object*\"?[^>]*>/ig) || ($secvalue =~ m/<[^>]*iframe*\"?[^>]*>/ig) || ($secvalue =~ m/<[^>]*applet*\"?[^>]*>/ig) || ($secvalue =~ m/<[^>]*meta*\"?[^>]*>/ig) || ($secvalue =~ m/<[^>]*style*\"?[^>]*>/ig) || ($secvalue =~ m/<[^>]*form*\"?[^>]*>/ig) || ($secvalue =~ m/\"/ig)) {
				if($notify_script){
				$abuse_subject = qq~$txt_gl{'132'}-($fi_fbname): $txt_gd{'15'} $txt_gd{'2'}~;
				$abuse_mail = qq~$txt_gd{'15'} $txt_gd{'2'} $txt_gl{'122'} $datum\n\n$txt_gd{'3'}: $user_ip\n~;
				if($addip_script){
				$abuse_mail .= qq~$txt_gd{'4'}: $user_ip,\n\n~;
				}
				$printstring = $ENV{'QUERY_STRING'};
				$printstring =~ s/</%3c/g;
				$printstring =~ s/>/%3e/g;
				$secvalue =~ s/</%3c/g;
				$secvalue =~ s/>/%3e/g;

				$abuse_mail .= qq~$txt_gd{'14'}: $script?$printstring\n$txt_gd{'23'}: $secvalue\n\n~;
				$abuse_mail .= qq~$fi_fbname, $txt_gl{'132'}~;
				&notifyadmin;
				}
				if($addip_script){
					&writefile("$datadir/admdat/bannip.dat","$user_ip\n","add");
				}
				$actionfree = 1;
				&fatal_error($txt_gd{'22'});
			}
		}
		while( ($key,$secvalue) = each(%FORM) ) {
			$secvalue = lc($secvalue);
			&str_replace("%3c", "<", $secvalue);
			&str_replace("%3e", ">", $secvalue);
			if (($secvalue =~ m/<[^>]script*\"?[^>]*>/ig) || ($secvalue =~ m/<[^>]style*\"?[^>]*>/ig)) {
				if($notify_script){
				$abuse_subject = qq~$txt_gl{'132'}-($fi_fbname): $txt_gd{'15'} $txt_gd{'2'}~;
				$abuse_mail = qq~$txt_gd{'15'} $txt_gd{'2'} $txt_gl{'122'} $datum\n\n$txt_gd{'3'}: $user_ip\n~;
				if($addip_script){
				$abuse_mail .= qq~$txt_gd{'4'}: $user_ip,\n\n~;
				}
				$printstring = $ENV{'QUERY_STRING'};
				$printstring =~ s/</%3c/g;
				$printstring =~ s/>/%3e/g;
				$secvalue =~ s/</%3c/g;
				$secvalue =~ s/>/%3e/g;
				$abuse_mail .= qq~$txt_gd{'16'}: $script?$printstring\n$txt_gd{'23'}: $secvalue\n\n~;
				$abuse_mail .= qq~$fi_fbname, $txt_gl{'132'}~;
				&notifyadmin;
				}
				if($addip_script){
					&writefile("$datadir/admdat/bannip.dat","$user_ip\n","add");
				}
				$actionfree = 1;
				&fatal_error($txt_gd{'22'});
			}
		}
	}
			}
return;
}
sub get_request_method {
	if ($ENV{'REQUEST_METHOD'}) {
		return $ENV{'REQUEST_METHOD'};
	} else {
		return "empty";
	}
}
sub get_script_name {
	if ($ENV{'SCRIPT_NAME'}) {
		return $ENV{'SCRIPT_NAME'};
	} else {
		return "empty";
	}
}
sub get_http_host {
	if ($ENV{'HTTP_HOST'}) {
		return $ENV{'HTTP_HOST'};
	} else {
		return "empty";
	}
}
sub get_query_string {
	if ($ENV{'QUERY_STRING'}) {
		my $tempstring = &str_replace("%09", "%20", $ENV{'QUERY_STRING'});
		return &str_replace("%09", "%20", $ENV{'QUERY_STRING'});
	} else {
		return "empty";
	}
}
sub get_user_agent {
	if ($ENV{'HTTP_USER_AGENT'}) {
		return $ENV{'HTTP_USER_AGENT'};
	} else {
		return "empty";
	}
}
sub get_referer {
	if ($ENV{'HTTP_REFERER'}) {
		return $ENV{'HTTP_REFERER'};
	} else {
		return "empty";
	}
}
sub get_remote_port{
	if ($ENV{'REMOTE_PORT'}) {
		return $ENV{'REMOTE_PORT'};
	} else {
		return "empty";
	}
}
sub str_replace {
	my($org,$repl,$target) = @_;
	$target =~ s~$org~$repl~ig;
	return $target;
}
sub notifyadmin {
&sendmail2($admmail,$abuse_subject,$abuse_mail);
}
1;