####################### [i-dreams.net] - guestbook ############################
# validate.pl     		                                                      #
###############################################################################

$| = 1;

sub validate {

unless ($loaded_getcolors == 1) {
	require "$subsdir/getcolors.pl"; 
	&GetColors;
}
$background = $bgcolor{"fb2"};
$textcolor = $color{"fb2"};

$back1 = substr($background,1,2);
$back2 = substr($background,3,2);
$back3 = substr($background,5,2);
$tack1 = substr($textcolor,1,2);
$tack2 = substr($textcolor,3,2);
$tack3 = substr($textcolor,5,2);

$xb = hex "$back1"; 
$yb = chr($xb);
$xb = hex "$back2"; 
$yb .= chr($xb);
$xb = hex "$back3"; 
$yb .= chr($xb);
$backcolor = "$yb";
$xb = hex "$tack1"; 
$yb = chr($xb);
$xb = hex "$tack2"; 
$yb .= chr($xb);
$xb = hex "$tack3"; 
$yb .= chr($xb);
$highcolor = "$yb";
$shadecolor = "\x99\x99\x99";

	$lastvalue =13;

$message = $current_validation_code;

if (!$translayer || $translayer == "0"){ $TRANSPARENT_INDEX = "\3";} else {$TRANSPARENT_INDEX = "\0";}

$BITS_PER_PIXEL = 7;

$palette .= "$backcolor";
$palette .= "$shadecolor";
$palette .= "$highcolor";

$DOT_WIDTH = 3;
$DOT_HEIGHT = 3;

$dot = qq~
\1\2\1
\2\2\2
\1\2\1
~;
$nodot = qq~
\0\0\0
\0\0\0
\0\0\0
~;

$CHAR_WIDTH = 6;
$CHAR_HEIGHT = 9;

$ci{'0'} = qq~
.XXX..
X...X.
X..XX.
X.X.X.
XX..X.
X...X.
.XXX..
......
......
~;
$ci{'1'} = qq~
..X...
.XX...
..X...
..X...
..X...
..X...
.XXX..
......
......
~; 
$ci{'2'} = qq~
.XXX..
X...X.
....X.
...X..
..X...
.X....
XXXXX.
......
......
~; 
$ci{'3'} = qq~
XXXXX.
...X..
..X...
...X..
....X.
X...X.
.XXX..
......
......
~;
$ci{'4'} = qq~
...X..
..XX..
.X.X..
X..X..
XXXXX.
...X..
...X..
......
......
~;
$ci{'5'} = qq~
XXXXX.
X.....
XXXX..
....X.
....X.
X...X.
.XXX..
......
......
~;
$ci{'6'} = qq~
.XXX..
X...X.
X.....
XXXX..
X...X.
X...X.
.XXX..
......
......
~; 
$ci{'7'} = qq~
XXXXX.
....X.
...X..
..X...
.X....
.X....
.X....
......
......
~;
$ci{'8'} = qq~
.XXX..
X...X.
X...X.
.XXX..
X...X.
X...X.
.XXX..
......
......
~;
$ci{'9'} = qq~
.XXX..
X...X.
X...X.
.XXXX.
....X.
X...X.
.XXX..
......
......
~; 
$ci{'a'} = qq~
......
......
.XXX..
....X.
.XXXX.
X...X.
.XXXX.
......
......
~; 
$ci{'b'} = qq~
X.....
X.....
XXXX..
X...X.
X...X.
X...X.
XXXX..
......
......
~;
$ci{'c'} = qq~
......
......
.XXXX.
X.....
X.....
X.....
.XXXX.
......
......
~;
$ci{'d'} = qq~
....X.
....X.
.XXXX.
X...X.
X...X.
X...X.
.XXXX.
......
......
~;
$ci{'e'} = qq~
......
......
.XXX..
X...X.
XXXXX.
X.....
.XXXX.
......
......
~;
$ci{'f'} = qq~
...XX.
..X...
.XXX..
..X...
..X...
..X...
.XXX..
......
......
~;
$ci{'g'} = qq~
......
......
.XXXX.
X...X.
X...X.
X...X.
.XXXX.
....X.
XXXX..
~;
$ci{'h'} = qq~
X.....
X.....
XXXX..
X...X.
X...X.
X...X.
X...X.
......
......
~; 
$ci{'i'} = qq~
..X...
......
.XX...
..X...
..X...
..X...
.XXX..
......
......
~;
$ci{'j'} = qq~
..X...
......
.XX...
..X...
..X...
..X...
..X...
..X...
XX....
~;
$ci{'k'} = qq~
X.....
X.....
X...X.
X..X..
XXX...
X..X..
X...X.
......
......
~;
$ci{'l'} = qq~
..X...
..X...
..X...
..X...
..X...
..X...
..XX..
......
......
~; 
$ci{'m'} = qq~
......
......
XXXX..
X.X.X.
X.X.X.
X.X.X.
X.X.X.
......
......
~;
$ci{'n'} = qq~
......
......
XXXX..
X...X.
X...X.
X...X.
X...X.
......
......
~; 
$ci{'o'} = qq~
......
......
.XXX..
X...X.
X...X.
X...X.
.XXX..
......
......
~;
$ci{'p'} = qq~
......
......
XXXX..
X...X.
X...X.
X...X.
XXXX..
X.....
X.....
~;
$ci{'q'} = qq~
......
......
.XXXX.
X...X.
X...X.
X...X.
.XXXX.
....X.
....X.
~;
$ci{'r'} = qq~
......
......
X.XX..
XX..X.
X.....
X.....
X.....
......
......
~;
$ci{'s'} = qq~
......
......
.XXXX.
X.....
.XXX..
....X.
XXXX..
......
......
~;
$ci{'t'} = qq~
..X...
..X...
.XXX..
..X...
..X...
..X...
...X..
......
......
~; 
$ci{'u'} = qq~
......
......
X...X.
X...X.
X...X.
X..XX.
.XX.X.
......
......
~;
$ci{'v'} = qq~
......
......
X...X.
X...X.
X...X.
.X.X..
..X...
......
......
~;
$ci{'w'} = qq~
......
......
X...X.
X.X.X.
X.X.X.
.XXX..
.X.X..
......
......
~;
$ci{'x'} = qq~
......
......
X...X.
.X.X..
..X...
.X.X..
X...X.
......
......
~;
$ci{'y'} = qq~
......
......
X...X.
X...X.
X...X.
X...X.
.XXXX.
....X.
.XXX..
~;
$ci{'z'} = qq~
......
......
XXXXX.
...X..
..X...
.X....
XXXXX.
......
......
~; 

$nl = length qq~
~;

$len = length $message;
$w = $len * $CHAR_WIDTH * $DOT_WIDTH;
$h = $CHAR_HEIGHT * $DOT_HEIGHT;
$BLOCK_LIMIT = 2**$BITS_PER_PIXEL - 3;

print 'Content-type: image/gif', "\n\n";

print $TRANSPARENT_INDEX ? 'GIF89a' : 'GIF87a';

print pack 'v2', $w, $h; 
print pack 'C1', 0xF0 + $BITS_PER_PIXEL - 1;
print "\0";
print "\0";
print $palette;
print "\0" x ((2**$BITS_PER_PIXEL * 3) - length $palette);

if ($TRANSPARENT_INDEX) {
  print "\x21";
  print "\xF9";
  print "\x04";
  print "\x01";
  print "\0\0";
  print $TRANSPARENT_INDEX;
  print "\0";
}

print ',';
print "\0\0\0\0";
print pack 'v2', $w, $h;
print "\0";

print pack 'C1', $BITS_PER_PIXEL;

$togo = $w * $h;
$cnt = 0;
print pack 'C1', (($togo > $BLOCK_LIMIT) ? $BLOCK_LIMIT : $togo) + 1;
for ($y = 0; $y < $h; $y++) {
  $cy = int($y / $DOT_HEIGHT);
  for ($x = 0; $x < $w; $x++) {
    $cx = int($x / $DOT_WIDTH) % $CHAR_WIDTH;
    $msgi = int($x / $DOT_WIDTH / $CHAR_WIDTH);
    $c = substr $message, $msgi, 1;
    $d = substr $ci{$c}, $cy * ($CHAR_WIDTH + $nl) + $cx + $nl, 1;
    $dx = $x % $DOT_WIDTH;
    $dy = $y % $DOT_HEIGHT;
    $di = ($d eq 'X') ? $dot : $nodot;
    print substr $di, $dy * ($DOT_WIDTH + $nl) + $dx + $nl, 1;
    $cnt++;
    $togo--;
    if ($cnt >= $BLOCK_LIMIT) {
      print pack 'C1', 2**$BITS_PER_PIXEL;
      $cnt = 0;
      print pack 'C1', (($togo > $BLOCK_LIMIT) ? $BLOCK_LIMIT : $togo) + 1;
    }
  }
}
print pack 'C1', 2**$BITS_PER_PIXEL + 1;
print "\0";
print ';';
}

1;